// Copyright 2012 Interface3 Ltd. All rights reserved.
var dndStartPositions = {};
var MAX_FONT_SIZE_FOR_WORD = 60;

NB.ready(function() {

    loadSettings();

    //$(window).resize(function() {
    //    $('#word').css('width', $('#word-box').width() - ($('#box-left').width() + $('#box-right').width()));
        checkResizeText();
    //});
    //$(window).trigger('resize');
    
    try {
        addDragAndDropHandlers();
    } catch(err) {
        console.log("no drag-drop suuport because not running in notebook");
    }

    $('#close-btn').click(function() {
        NB.page.deleteObject(NB.getObject(NB.HOSTGUID));
    });
    
    $('#spreadLetters,#groupLetters').click(function() {
        if($('#groupLetters').is(":visible")) {
            $('#groupLetters').hide();
            $('#spreadLetters').show();
        } else {
            $('#groupLetters').show();
            $('#spreadLetters').hide();
        }
    });
    
    $('#toPage-btn').click(function() {
        if($('#word').val() != "Write here or drag and drop") {
            splitText();
        }
    });
    
    $('#word').click(function() {
        if($(this).val() == "Write here or drag and drop") {
            $(this).val("");
        }
    });
    
    $('#word').keyup(function() {
        checkResizeText();
        saveSettings();
    });
    
});

function saveSettings() {
    try {
        details = {};
        details['word'] = $('#word').val();
        NB.persist.save("wordBreak-up", details);
    } catch(error) {
        console.log("Failed to save settings because notebook is not running");
    }
}

function loadSettings() {
    var loadResults = NB.persist.load('wordBreak-up')
    if(loadResults != null) {
        var settings = JSON.parse(loadResults);
        showWord(settings.word);
    }
}


function checkResizeText() {
    $('#word').css('font-size', MAX_FONT_SIZE_FOR_WORD + "px");
  
    if($('#word')[0].scrollWidth > $('#word').width()) {
        currentTextSize = parseInt($('#word').css('font-size').slice(0, -2));
        console.log("currentTextSize: " + currentTextSize);
        while($('#word')[0].scrollWidth > $('#word').width()) {
            currentTextSize -= 1;
            $('#word').css('font-size', currentTextSize + "px");
            console.log("currentTextSize: " + currentTextSize);
        }
    
    }
}

function splitText() {
    var text = $('#word').val();
    console.log("split: " + text);
    
    if($('#groupLetters').is(":visible")) { // don't split text
        injectTextOntoPage(text);
    } else {    
        for(var letterIndex = 0; letterIndex < text.length; letterIndex++) {
            injectTextOntoPage(text[letterIndex]);
        }
    }
    
}

function showWord(newText) {
	$('#word').val(newText);
	checkResizeText();
	saveSettings();
}

function addDragAndDropHandlers() {
    NB.addObserver("dndStartEvent", function(evt) {
        for(var guid in evt.eventData) {
            dndStartPositions[guid] = {x: evt.eventData[guid].x, y: evt.eventData[guid].y};
        }
    });
    
    NB.addObserver("dndDropEvent", function(evt) {
        // From here, based on the event, you can do a hit test.
        // For example, lets see if it hit "myself", the widget.
        for(var guid in evt.eventData) {
            var contact = evt.eventData[guid].contact;
            if(NB.getObject(NB.HOSTGUID).contains(contact.x, contact.y)) {
                
                droppedObject = NB.getObject(guid);
                
                // for handwritten text the type is ink. get the recognised text with .getText
                // for group text the type is group. get the recognised text with .getText
                // for non-handwritten text the type is text. get the recognised text with .text
                droppedText = null;

                if(droppedObject.type == "ink" || droppedObject.type == "group") {
                    // Get the text from that annotation
                    // This automatically invokes handwriting recognition when used on ink annotations
                    recognisedText = droppedObject.getText();
                    if(isDefined(recognisedText)) {
                        droppedText = recognisedText.toString();
                    }
                } else if(droppedObject.type == "text") {
                    droppedText = droppedObject.text;
                }

                if(droppedText != null) {
                    showWord(droppedText);
                    //splitText();
                    replaceObjectWhereItCameFromBeforeDragAndDrop(droppedObject);
                }
                
                
            }
        }
    });
}

function replaceObjectWhereItCameFromBeforeDragAndDrop(droppedObject) {
    if(droppedObject.guid in dndStartPositions) {
        droppedObject.x = dndStartPositions[droppedObject.guid].x;
        droppedObject.y = dndStartPositions[droppedObject.guid].y;
    }
    dndStartPositions = {}; // reset the drag and drop starting position. May overwrite values if multiple drags are started at the same time but this is unlikely to happen
}

function injectTextOntoPage(newText) {

    for(var letterIndex = 0; letterIndex < newText.length; letterIndex++) {
    
        var newAnn = NB.objectPrototype.text(newText[letterIndex]);
        var rect = NB.page.getVisibleArea();
        var allObjects = NB.page.getObjectsAsArray();
        
        var newAnnWidthGuestimate = (50 * newText.length);
        var numberOfTries = 10;
        var distanceFromObject = 0;
        var self = NB.getObject(NB.HOSTGUID);
    
    
        if(letterIndex == 0) { // if this is the first letter of several or the only letter then place it randomly where there's space
    
            do {
            
/*                if(1 == Math.round(Math.random() * 1)) { // to the side
                    
                    if(1 == Math.round(Math.random() * 1)) {
                        newAnn.x = self.x - newAnnWidthGuestimate - distanceFromObject; // left
                    } else {
                        newAnn.x = self.x + self.width + distanceFromObject; // right // newAnn.width returns NaN so use a guestimate
                    }
                    newAnn.y = self.y + (self.height * 0.05) +  Math.floor(Math.random() * (self.height * 0.6));
                } else { // or above/ below
*/                    
                    newAnn.x = self.x + (self.width * 0.05) + Math.floor(Math.random() * ((self.width - newAnnWidthGuestimate) * 0.9));
                    if(1 == Math.round(Math.random() * 1)) {
                        newAnn.y = self.y - 20 - distanceFromObject; // bottom (- newAnn.height cause an error - use 20 instead)
                    } else {
                        newAnn.y = self.y + self.height + distanceFromObject; // top
                    }
                //}
                
                if(numberOfTries % 2 == 0 && numberOfTries != 10) {
                    distanceFromObject += 10;
                }
                numberOfTries--;
                //console.log("!inBounds(newAnn, rect): " + !inBounds(newAnn, rect) + ", clashing(newAnn, self, allObjects): " + clashing(newAnn, self, allObjects));
                
            } while(((!inBounds(newAnn, newAnnWidthGuestimate, rect)) || clashing(newAnn, self, allObjects)) && numberOfTries > 0)
        } else {
            // place the text after the previous text
            newAnn.x = oldAnn.x + (newAnnWidthGuestimate / newText.length);
            newAnn.y = oldAnn.y;
        }
        newAnn.font.size = 26;
        
        NB.addObject(newAnn);
        var oldAnn = newAnn;
    }
    return newAnn;
}

function clashing(thingToTest, self, allObjects) {
    //var clashingObjects = NB.page.getObjectsAtPoint(thingToTest.x, thingToTest.y); // call does not work and array is always empty
    
    // the text object has no width or height to check against so guestimate it
    var thingTotestWidthGuestimate = thingToTest.font.size;
    var thingTotestHeightGuestimate = thingToTest.font.size;
    
    for(x = thingToTest.x; x <= thingToTest.x + thingTotestWidthGuestimate; x += (thingTotestWidthGuestimate / 2)) {
        for(y = thingToTest.y; y <= thingToTest.y + thingTotestHeightGuestimate; y += (thingTotestHeightGuestimate / 2)) {
            
            for(thingIndex = 0; thingIndex < allObjects.length; thingIndex++) {
                if(allObjects[thingIndex].guid != self.guid) {
                    if((x < allObjects[thingIndex].x) ||
                        (y < allObjects[thingIndex].y) ||
                        (x > (allObjects[thingIndex].x + allObjects[thingIndex].width)) ||
                        (y > (allObjects[thingIndex].y + allObjects[thingIndex].height))) {
                           // do nothing
                    } else  {
                        return true;
                    }
                }
            }
            
        }
    }
    return false;
    
}

function inBounds(thingToTest, thingToTestGuestimateWidth, rect) {
    
    if((thingToTest.x < rect.x) ||
        (thingToTest.y < rect.y) ||
        ((thingToTest.x + thingToTestGuestimateWidth) > (rect.x + rect.width)) ||
        ((thingToTest.y + 50) > (rect.y + rect.height))) {
            return false;
        }
        
        return true;
}

